#auto_version

#import <shaders/include/instanced.glsl>
#import <shaders/include/rect_offsets.glsl>
#import <shaders/include/text.glsl>

const vec2 TEX_OFFSET_BASE = vec2(-0.5 / 8.0, 0.0 / 8.0);
const vec2 TEX_OFFSET_MULTIPLIER = vec2((8.0 - 1.5) / 8.0, (8.0 - 0.0) / 8.0) - TEX_OFFSET_BASE;

// instance attributes
in vec2 Position;
in float Size;
in vec4 Color;
in uint Char;
in uint Flags;
in vec2 UVBase;
/**
 * In pixels.
 */
in uint UVExtent;

/* IIUC, the spec says that it is not required to duplicate the `centroid` modifier here. But apparently Windows
   requires it. */
centroid out vec2 vUV;
out float localTexCoord0Y;
out vec4 vColor;
out float vBold;
out float vStrike;
out float vUnderline;

void main() {
    vec2 offset = Offset * TEX_OFFSET_MULTIPLIER;
    vec2 localPosition = offset;
    if (bool(Flags & FLAG_ITALIC)) {
        localPosition -= vec2(offset.y / 4.0, 0.0);
    }
    vec2 pos = Position + (localPosition * Size);
    gl_Position = projectPos(pos);

    applyClip(pos);

    uint ui = Char & uint(15);
    uint vi = Char >> uint(4);
    vUV = (vec2(ui, vi) + TEX_OFFSET_BASE + offset) * UVExtent / float(#atlas_size);
    localTexCoord0Y = mod(vUV.y, SUPER_PIXEL * float(UVExtent)) / (SUPER_PIXEL * float(UVExtent / PIXELS_PER_CHAR));
    vUV += UVBase;
    vColor = Color;
    vBold = float(bool(Flags & FLAG_BOLD));
    vStrike = float(bool(Flags & FLAG_STRIKE));
    vUnderline = float(bool(Flags & FLAG_UNDERLINE));
}
